
; RUTINA DE -VLA- PARA ROTAR UN PUNTO
; GRACIAS! VLA
;
; Algunas modificaciones para eliminar codigo que no se utilizaba e
; intentar optimizar 
; Recomendado leerse el 3DROTATE.DOC de VLA!!!!!!!!!!!!!!!!



INCLUDE sincos.dw       ;Labels SINE: and COSINE: contains sine(0-255)*256


;=== DATA Structures
    
Angle_Union     UNION
        B       db  0
        W       dw  0
Angle_Union     ENDS    ;CREAR UN NUEVO TIPO DE DATOS

Point_Struc     STRUC
        X       dw  ?
        Y       dw  ?
        Z       dw  ?
        C       dw  ?      
Point_Struc     ENDS    ;CREAR UNA ESTRUCTURA DE DATOS


Distancia       dw    300       ; DISTANCIA 
NumBolas        EQU   60        ; Numero Total de Bolas

XYZcord  LABEL Point_Struc
         INCLUDE BOLAS.RND      ; Las coordenadas de la bolas
                 
RotCord     Point_Struc NumBolas DUP(<>)    ;Copia de las coordenadas rotadas

OffBola     dw    NumBolas  DUP (0)     ; Aqui guardamos la direccion definitiva
                                        ; de la bola, para despues hacer un
                                        ; borrado rapido, sin necesidad de
                                        ; calcular otra vez
PtroBola    dw    offset OffBola        ; Puntero a la Bola

Zan         Angle_Union <?,?>
Yan         Angle_Union <?,?>   ; the '?' defaults to zero, but you can't
Xan         Angle_Union <?,?>   ;specify in a Union
                                
YanVel      db    1             ; Velocidad de rotacion 
ZanVel      db    0

CentroX     dw  -200             ; Centro del eje de rotacion en pantalla
CentroY     dw  100    

Color       dw  0               ; Color de la Bola


;=== SUBROUTINES
  
;DESTROYS: ax,dx,si,di,es,ds
;Input: BX= X CX= Y BP= Z
;OutPut:BX= X CX= Y BP= Z

RotateXYZ proc 
        Mov     ax,cs
        Mov     ds,ax                       ; X-rotation
                                            ; Y := cos(Xan) * y - sin(Xan) * z
                                            ; Z := sin(Xan) * y + cos(Xan) * z
        Mov     si,[Xan.W]
        Add     si,si                       ; si = angle x
        Mov     ax,[Cosine+si]              ; ax = cos(angle x)
        Imul    cx                          ; ax = cos(angle x) * y
        Mov     di,dx
        Shl     edi,16
        Mov     di,ax                       ; store for later use
        Mov     ax,[Sine+si]                ; ax = sin(angle x)
        Imul    bp                          ; ax = sin(angle x) * z
        Shl     edx,16
        Mov     dx,ax
        Sub     edi,edx                     ; di = di-ax = cos(vx)*y - sin(vz)*z
        Sar     edi,8                       ; remove the (co)sin "256-factor"
        Mov     es,di                       ; es = x-coordinate

        Mov     ax,[sine+si]                ; ax = sin(angle x)
        Imul    cx                          ; ax = sin(angle x) * y
        Mov     di,dx
        Shl     edi,16
        Mov     di,ax
        Mov     ax,[cosine+si]              ; ax = cos(angle x)
        Imul    bp                          ; ax = cos(angle x) * z
        Shl     edx,16
        Mov     dx,ax
        Add     edi,edx                     ; di = di-ax = sin(vx)*y + cos(vx)*z
        Sar     edi,8                       ; remove the (co)sin "256-factor"

        Mov     cx,es                       ; update y
        Mov     bp,di                       ; update z

                                        ; Y-rotation
                                        ; X :=  cos(vy) * xc + sin(vy) * zc
                                        ; Z := -sin(vy) * xc + cos(vy) * zc
        Mov     si,[Yan.W]
        Add     si,si                       ; si = angle y
        Mov     ax,[Cosine+si]              ; ax = cos(angle y)
        Imul    bx                          ; ax = cos(angle y) * x
        Mov     di,dx
        Shl     edi,16
        Mov     di,ax                       ; store for later use
        Mov     ax,[Sine+si]                ; ax = sin(angle y)
        Imul    bp                          ; ax = sin(angle y) * z
        Shl     edx,16
        Mov     dx,ax
        Add     edi,edx                     ; di = di+ax = cos(vy)*x + sin(vy)*z
        Sar     edi,8                       ; remove the (co)sin "256-factor"
        Mov     es,di                       ; es = x-coordinate

        Mov     ax,[Sine+si]                ; ax = sin(angle y)
        Neg     ax                          ; ax =-sin(angle y)
        Imul    bx                          ; ax =-sin(angle y) * x
        Mov     di,dx
        Shl     edi,16
        Mov     di,ax
        Mov     ax,[Cosine+si]              ; ax = cos(angle y)
        Imul    bp                          ; ax = cos(angle y) * z
        Shl     edx,16
        Mov     dx,ax
        Add     edi,edx                     ; di = di-ax = sin(vy)*x - cos(vy)*z
        Sar     edi,8                       ; remove the (co)sin "256-factor"

        Mov     bx,es                       ; update x
        Mov     bp,di                       ; update z

                                        ; Z-rotation
                                        ; X := cos(vz) * xc - sin(vz) * yc
                                        ; Y := sin(vz) * xc + cos(vz) * yc
        Mov     si,[Zan.W]
        Add     si,si                       ; si = angle z
        Mov     ax,[Cosine+si]              ; ax = cos(angle z)
        Imul    bx                          ; ax = cos(angle z) * x
        Mov     di,dx
        Shl     edi,16
        Mov     di,ax
        Mov     ax,[Sine+si]                ; ax = sin(angle z)
        Imul    cx                          ; ax = sin(angle z) * y
        Shl     edx,16
        Mov     dx,ax
        Sub     edi,edx                     ; di = di-ax = cos(vz)*x - sin(vz)*y
        Sar     edi,8                       ; remove the (co)sin "256-factor"
        Mov     es,di                       ; es = x-coordinate

        Mov     ax,[Sine+si]                ; ax = sin(angle z)
        Imul    bx                          ; ax = sin(angle z) * x
        Mov     di,dx
        Shl     edi,16
        Mov     di,ax
        Mov     ax,[Cosine+si]              ; ax = cos(angle z)
        Imul    cx                          ; ax = cos(angle z) * y
        Shl     edx,16
        Mov     dx,ax
        Add     edi,edx                     ; di = di+ax = sin(vz)*x+cos(vz)*y
        Sar     edi,8                       ; remove the (co)sin "256-factor"

        Mov     bx,es                       ; update x
        Mov     cx,di                       ; update y
    
        Ret
RotateXYZ   ENDP

RotarBolas  PROC 
        Push    Bp
        Push    Cs
        Pop     Ds

        Mov     Di,0                    ;Puntero a las Bolas
SigBola:
        Mov     Bx,[XYZcord.X +Di]      ;Coordenadas a rotar
        Mov     Cx,[XYZcord.Y +Di]
        Mov     Bp,[XYZcord.Z +Di]

        Push    Di
        Call    RotateXYZ
        Pop     Di

        Mov     [RotCord.X +di],Bx  ; Guardamos las coordenadas rotadas para   
        Mov     [RotCord.Y +di],Cx  ; hacer la proyeccion a 2D posteriormente
        Add     Bp,[Distancia]
        Mov     [RotCord.Z +di],Bp

        Add     Di,8            ; Cada Bola tiene un tamao de 8 bytes
        Cmp     Di,NumBolas*8   ; Estan todas las bolas
        Jb      SigBola         ; No. Siguiente bola

        Mov     Al,[YanVel]
        Add     [Yan.b],Al      ; Actualizo el Angulo sobre el Eje Y
        Mov     Al,[ZanVel]
        Add     [Zan.b],Al      ; Actualizo el Angulo sobre el Eje Z        

        Pop     Bp
        Ret
RotarBolas  ENDP

PonerBolas  PROC 
        Push    Bp
        Mov     Ax,0A000h   
        Mov     Es,Ax
        Mov     Ax,Cs
        Mov     Ds,Ax
    
        Mov     Bp,0        ;point counter
    
        Mov     Bx,[PtroBola]
SigBola2:
        Mov     Cx,15
        Mov     Si,Bp
        Add     Si,Si
        Shl     Si,2        ;si= bp*8

        Mov     Al,Byte Ptr [XYZCord.C +Si]
        Mov     Ah,66
        Mov     [Color],Ax
        
        Mov     Di,Cs:[Bx]
        Cmp     Di,0
        Je      NoHayBola
        Call    ClsBola
NoHayBola:
    
    ;OFFSET BOLA = 320 * (Y + CentroY) + X + CentroX
    
        Mov     Cx,[RotCord.Z +Si]
        Mov     Ax,[RotCord.Y +Si]
        Movsx   Dx,Ah
        Shl     Ax,8
        Idiv    Cx              
        Add     Ax,[CentroY]   
        Mov     Di,Ax
        Cmp     Di,190
        Jae     NoPoner 
        Cmp     Di,20
        Jbe     NoPoner 
        Imul    Di,320

        Mov     Ax,[RotCord.X +Si]
        Movsx   Dx,Ah
        Shl     Ax,8
        Idiv    Cx              
        Add     Ax,[CentroX]
        Cmp     Ax,320
        Jae     NoPoner
        Cmp     Ax,0
        Jbe     NoPoner   
        Add     Di,Ax
        Mov     [Bx],Di
    
        Mov     Ax,[Color]
        Call    PonBola

SiguePoniendo:
        Add     Bx,2
        Inc     Bp
        Cmp     Bp,NumBolas       
        Jb      SigBola2   
        Pop     Bp
        Ret
NoPoner:
        Mov     Word Ptr [Bx],0
        Jmp     SiguePoniendo
PonerBolas  ENDP

; PonBola y ClsBola:
;
; He utilizado el ADD para dar la sensacion de transparencia de las letras
; bueno, ya sabeis de que hablo :)


; Di: Offset situacion de la Bola
; Ax: Color
PonBola Proc
        Add     Es:[Di],Al
        Add     Es:[Di+1],Al
        Add     Es:[Di+319],Al
        Add     Es:[Di+320],Al
        Add     Es:[Di+321],Ah
        Add     Es:[Di+322],Al
        Add     Es:[Di+319+320],Al
        Add     Es:[Di+320+320],Al
        Add     Es:[Di+321+320],Al
        Add     Es:[Di+322+320],Al        
        Add     Es:[Di+960],Al
        Add     Es:[Di+961],Al
        Ret
PonBola Endp

; Di: Offset situacion de la Bola
; Ax: Color
ClsBola Proc
        Sub     Es:[Di],Al
        Sub     Es:[Di+1],Al
        Sub     Es:[Di+319],Al
        Sub     Es:[Di+320],Al
        Sub     Es:[Di+321],Ah
        Sub     Es:[Di+322],Al
        Sub     Es:[Di+319+320],Al
        Sub     Es:[Di+320+320],Al
        Sub     Es:[Di+321+320],Al
        Sub     Es:[Di+322+320],Al        
        Sub     Es:[Di+960],Al
        Sub     Es:[Di+961],Al
        Ret
ClsBola Endp
